
package jmsserver;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Named;
import javax.jms.Topic;
import javax.jms.TopicConnectionFactory;

import javax.jms.JMSContext;
import javax.jms.JMSException;
import javax.jms.Message;

@Named
@ApplicationScoped
public class ComputeServer
{
    
   @Resource(lookup = "jms/topicfactory")
    private TopicConnectionFactory connectionFactory;

    @Resource(lookup = "jms/topic")
    private Topic topic;
    
    int count = 0;

    JMSContext context;
    
    @PostConstruct
    private void init()
    {
        context = connectionFactory.createContext();
    }
        
    public ComputeServer() {
    }
    
   public String getCount() {  return Integer.toString(count);   }
   public void setCount(String newCount) { count = Integer.parseInt(newCount); } 
 
    private void sendResponse(String response, String originalMsgId) throws JMSException
    {
        Message msg = context.createTextMessage(response);
        msg.setJMSCorrelationID(originalMsgId);
        msg.setStringProperty("Direction", "ToClient");
        context.createProducer().send(topic, msg);        
    }
    
    void compute(String comp, String msgId) throws JMSException
    {
        double result = 0.0;
        String args[] = comp.split(";");
        int a = Integer.parseInt(args[0]);
        int b = Integer.parseInt(args[1]);
        int op = Integer.parseInt(args[2]);
        switch (op)
        {
            case 1: result = a + (double)b; break;
            case 2: result = a - (double)b; break;
            case 3: result = a * (double)b; break;
            case 4: result = a / (double)b; break;
        }
        if (result > 0.0)
            try {  Thread.sleep((int)(1000.0 * result));  } catch (InterruptedException ex) {}
        sendResponse(Double.toString(result), msgId);
        count++;
    }
}
